﻿using System;
using System.Collections.Generic;
using Microsoft.EntityFrameworkCore;

namespace AvaloniaApplication3.Models;

public partial class TestDataBaseCheskinaContext : DbContext
{
    public TestDataBaseCheskinaContext()
    {
    }

    public TestDataBaseCheskinaContext(DbContextOptions<TestDataBaseCheskinaContext> options)
        : base(options)
    {
    }

    public virtual DbSet<AcademicSubject> AcademicSubjects { get; set; }

    public virtual DbSet<AcademicSubjectsStudentsStudyList> AcademicSubjectsStudentsStudyLists { get; set; }

    public virtual DbSet<CodeAcademicSubject> CodeAcademicSubjects { get; set; }

    public virtual DbSet<EducationStudent> EducationStudents { get; set; }

    public virtual DbSet<MdkWithModule> MdkWithModules { get; set; }

    public virtual DbSet<Module> Modules { get; set; }

    public virtual DbSet<ModulesStudentsStudyList> ModulesStudentsStudyLists { get; set; }

    public virtual DbSet<Program> Programs { get; set; }

    public virtual DbSet<ProgramsWithAcademicSubject> ProgramsWithAcademicSubjects { get; set; }

    public virtual DbSet<ProgramsWithModule> ProgramsWithModules { get; set; }

    public virtual DbSet<RunningProgram> RunningPrograms { get; set; }

    public virtual DbSet<Student> Students { get; set; }

    public virtual DbSet<StudentsWithProgram> StudentsWithPrograms { get; set; }

    public virtual DbSet<User> Users { get; set; }

    public virtual DbSet<UsersLogin> UsersLogins { get; set; }

    public virtual DbSet<UsersWithRole> UsersWithRoles { get; set; }

    public virtual DbSet<Usersrole> Usersroles { get; set; }

    protected override void OnConfiguring(DbContextOptionsBuilder optionsBuilder)
#warning To protect potentially sensitive information in your connection string, you should move it out of source code. You can avoid scaffolding the connection string by using the Name= syntax to read it from configuration - see https://go.microsoft.com/fwlink/?linkid=2131148. For more guidance on storing connection strings, see http://go.microsoft.com/fwlink/?LinkId=723263.
        => optionsBuilder.UseNpgsql("Host=edu.pg.ngknn.local;Port=5432;Database=testDataBaseCheskina;Username=41P;Password=12357");

    protected override void OnModelCreating(ModelBuilder modelBuilder)
    {
        modelBuilder.Entity<AcademicSubject>(entity =>
        {
            entity.HasKey(e => e.IdAcademicSubject).HasName("academic_subjects_pk");

            entity.ToTable("academic_subjects");

            entity.Property(e => e.IdAcademicSubject)
                .UseIdentityAlwaysColumn()
                .HasColumnName("id_academic_subject");
            entity.Property(e => e.IdCodeAcademicSubject)
                .HasColumnType("character varying")
                .HasColumnName("id_code_academic_subject");
            entity.Property(e => e.NameSubject)
                .HasColumnType("character varying")
                .HasColumnName("name_subject");

            entity.HasOne(d => d.IdCodeAcademicSubjectNavigation).WithMany(p => p.AcademicSubjects)
                .HasForeignKey(d => d.IdCodeAcademicSubject)
                .HasConstraintName("academic_subjects_fk");
        });

        modelBuilder.Entity<AcademicSubjectsStudentsStudyList>(entity =>
        {
            entity
                .HasNoKey()
                .ToTable("academic_subjects_students_study_list");

            entity.Property(e => e.Grade).HasColumnName("grade");
            entity.Property(e => e.IdAcademicSubjects).HasColumnName("id_academic_subjects");
            entity.Property(e => e.IdStudent).HasColumnName("id_student");

            entity.HasOne(d => d.IdAcademicSubjectsNavigation).WithMany()
                .HasForeignKey(d => d.IdAcademicSubjects)
                .HasConstraintName("academic_subjects_students_study_list_fk_1");

            entity.HasOne(d => d.IdStudentNavigation).WithMany()
                .HasForeignKey(d => d.IdStudent)
                .HasConstraintName("academic_subjects_students_study_list_fk");
        });

        modelBuilder.Entity<CodeAcademicSubject>(entity =>
        {
            entity.HasKey(e => e.IdCodeAcademicSubject).HasName("code_academic_subject_pk");

            entity.ToTable("code_academic_subject");

            entity.Property(e => e.IdCodeAcademicSubject)
                .HasColumnType("character varying")
                .HasColumnName("id_code_academic_subject");
        });

        modelBuilder.Entity<EducationStudent>(entity =>
        {
            entity.HasKey(e => e.IdEducation).HasName("education_students_pk");

            entity.ToTable("education_students");

            entity.Property(e => e.IdEducation)
                .UseIdentityAlwaysColumn()
                .HasColumnName("id_education");
            entity.Property(e => e.Name)
                .HasColumnType("character varying")
                .HasColumnName("name");
        });

        modelBuilder.Entity<MdkWithModule>(entity =>
        {
            entity
                .HasNoKey()
                .ToTable("mdk_with_modules");

            entity.Property(e => e.IdMdk).HasColumnName("id_mdk");
            entity.Property(e => e.IdModule).HasColumnName("id_module");

            entity.HasOne(d => d.IdMdkNavigation).WithMany()
                .HasForeignKey(d => d.IdMdk)
                .HasConstraintName("mdk_with_modules_fk_academic_subjects");

            entity.HasOne(d => d.IdModuleNavigation).WithMany()
                .HasForeignKey(d => d.IdModule)
                .HasConstraintName("mdk_with_modules_fk_modules");
        });

        modelBuilder.Entity<Module>(entity =>
        {
            entity.HasKey(e => e.IdModule).HasName("modules_pk");

            entity.ToTable("modules");

            entity.Property(e => e.IdModule)
                .UseIdentityAlwaysColumn()
                .HasColumnName("id_module");
            entity.Property(e => e.CodeModule)
                .HasColumnType("character varying")
                .HasColumnName("code_module");
            entity.Property(e => e.Name)
                .HasColumnType("character varying")
                .HasColumnName("name");
        });

        modelBuilder.Entity<ModulesStudentsStudyList>(entity =>
        {
            entity
                .HasNoKey()
                .ToTable("modules_students_study_list");

            entity.Property(e => e.Grade).HasColumnName("grade");
            entity.Property(e => e.IdModule).HasColumnName("id_module");
            entity.Property(e => e.IdStudent).HasColumnName("id_student");

            entity.HasOne(d => d.IdModuleNavigation).WithMany()
                .HasForeignKey(d => d.IdModule)
                .HasConstraintName("modules_students_study_list_fk");

            entity.HasOne(d => d.IdStudentNavigation).WithMany()
                .HasForeignKey(d => d.IdStudent)
                .HasConstraintName("modules_students_study_list_fk_1");
        });

        modelBuilder.Entity<Program>(entity =>
        {
            entity.HasKey(e => e.IdProgram).HasName("programs_pk");

            entity.ToTable("programs");

            entity.Property(e => e.IdProgram)
                .UseIdentityAlwaysColumn()
                .HasColumnName("id_program");
            entity.Property(e => e.Name)
                .HasColumnType("character varying")
                .HasColumnName("name");
        });

        modelBuilder.Entity<ProgramsWithAcademicSubject>(entity =>
        {
            entity.HasKey(e => e.Id).HasName("programs_with_academic_subjects_pk");

            entity.ToTable("programs_with_academic_subjects");

            entity.Property(e => e.Id)
                .UseIdentityAlwaysColumn()
                .HasColumnName("id");
            entity.Property(e => e.IdAcademicSubject).HasColumnName("id_academic_subject");
            entity.Property(e => e.IdProgram).HasColumnName("id_program");
            entity.Property(e => e.IdTeacher).HasColumnName("id_teacher");
            entity.Property(e => e.NumberOfHours).HasColumnName("number_of_hours");

            entity.HasOne(d => d.IdAcademicSubjectNavigation).WithMany(p => p.ProgramsWithAcademicSubjects)
                .HasForeignKey(d => d.IdAcademicSubject)
                .HasConstraintName("programs_with_academic_subjects_fk");

            entity.HasOne(d => d.IdProgramNavigation).WithMany(p => p.ProgramsWithAcademicSubjects)
                .HasForeignKey(d => d.IdProgram)
                .HasConstraintName("programs_with_academic_subjects_fk_1");

            entity.HasOne(d => d.IdTeacherNavigation).WithMany(p => p.ProgramsWithAcademicSubjects)
                .HasForeignKey(d => d.IdTeacher)
                .HasConstraintName("programs_with_academic_subjects_fk_2");
        });

        modelBuilder.Entity<ProgramsWithModule>(entity =>
        {
            entity.HasKey(e => e.Id).HasName("programs_with_modules_pk");

            entity.ToTable("programs_with_modules");

            entity.Property(e => e.Id)
                .UseIdentityAlwaysColumn()
                .HasColumnName("id");
            entity.Property(e => e.IdModule).HasColumnName("id_module");
            entity.Property(e => e.IdProgram).HasColumnName("id_program");
            entity.Property(e => e.IdTeacher).HasColumnName("id_teacher");

            entity.HasOne(d => d.IdModuleNavigation).WithMany(p => p.ProgramsWithModules)
                .HasForeignKey(d => d.IdModule)
                .HasConstraintName("programs_with_modules_fk_1");

            entity.HasOne(d => d.IdProgramNavigation).WithMany(p => p.ProgramsWithModules)
                .HasForeignKey(d => d.IdProgram)
                .HasConstraintName("programs_with_modules_fk");

            entity.HasOne(d => d.IdTeacherNavigation).WithMany(p => p.ProgramsWithModules)
                .HasForeignKey(d => d.IdTeacher)
                .HasConstraintName("programs_with_modules_fk_2");
        });

        modelBuilder.Entity<RunningProgram>(entity =>
        {
            entity.HasKey(e => e.IdRunningProgram).HasName("running_programs_pk");

            entity.ToTable("running_programs");

            entity.Property(e => e.IdRunningProgram)
                .UseIdentityAlwaysColumn()
                .HasColumnName("id_running_program");
            entity.Property(e => e.DateStart).HasColumnName("date_start");
            entity.Property(e => e.IdProgram).HasColumnName("id_program");

            entity.HasOne(d => d.IdProgramNavigation).WithMany(p => p.RunningPrograms)
                .HasForeignKey(d => d.IdProgram)
                .HasConstraintName("running_programs_fk");
        });

        modelBuilder.Entity<Student>(entity =>
        {
            entity.HasKey(e => e.IdStudent).HasName("students_pk");

            entity.ToTable("students");

            entity.Property(e => e.IdStudent)
                .UseIdentityAlwaysColumn()
                .HasColumnName("id_student");
            entity.Property(e => e.IdEducation).HasColumnName("id_education");
            entity.Property(e => e.Name)
                .HasColumnType("character varying")
                .HasColumnName("name");
            entity.Property(e => e.Patronumic)
                .HasColumnType("character varying")
                .HasColumnName("patronumic");
            entity.Property(e => e.Surname)
                .HasColumnType("character varying")
                .HasColumnName("surname");

            entity.HasOne(d => d.IdEducationNavigation).WithMany(p => p.Students)
                .HasForeignKey(d => d.IdEducation)
                .HasConstraintName("students_fk");
        });

        modelBuilder.Entity<StudentsWithProgram>(entity =>
        {
            entity.HasKey(e => e.Id).HasName("students_with_programs_pk");

            entity.ToTable("students_with_programs");

            entity.Property(e => e.Id)
                .UseIdentityAlwaysColumn()
                .HasColumnName("id");
            entity.Property(e => e.IdRunningProgram).HasColumnName("id_running_program");
            entity.Property(e => e.IdStudent).HasColumnName("id_student");

            entity.HasOne(d => d.IdRunningProgramNavigation).WithMany(p => p.StudentsWithPrograms)
                .HasForeignKey(d => d.IdRunningProgram)
                .HasConstraintName("students_with_programs_fk");

            entity.HasOne(d => d.IdStudentNavigation).WithMany(p => p.StudentsWithPrograms)
                .HasForeignKey(d => d.IdStudent)
                .HasConstraintName("students_with_programs_fk_1");
        });

        modelBuilder.Entity<User>(entity =>
        {
            entity.HasKey(e => e.IdUser).HasName("users_pk");

            entity.ToTable("users");

            entity.Property(e => e.IdUser)
                .UseIdentityAlwaysColumn()
                .HasColumnName("id_user");
            entity.Property(e => e.Name)
                .HasColumnType("character varying")
                .HasColumnName("name");
            entity.Property(e => e.Patronymic)
                .HasColumnType("character varying")
                .HasColumnName("patronymic");
            entity.Property(e => e.Surname)
                .HasColumnType("character varying")
                .HasColumnName("surname");
        });

        modelBuilder.Entity<UsersLogin>(entity =>
        {
            entity
                .HasNoKey()
                .ToTable("users_login");

            entity.HasIndex(e => e.IdUser, "users_login_id_user_un").IsUnique();

            entity.HasIndex(e => e.Login, "users_login_login_un").IsUnique();

            entity.Property(e => e.IdUser).HasColumnName("id_user");
            entity.Property(e => e.Login)
                .HasColumnType("character varying")
                .HasColumnName("login");
            entity.Property(e => e.Password)
                .HasColumnType("character varying")
                .HasColumnName("password");

            entity.HasOne(d => d.IdUserNavigation).WithOne()
                .HasForeignKey<UsersLogin>(d => d.IdUser)
                .HasConstraintName("users_login_fk");
        });

        modelBuilder.Entity<UsersWithRole>(entity =>
        {
            entity
                .HasNoKey()
                .ToTable("users_with_roles");

            entity.Property(e => e.IdRole).HasColumnName("id_role");
            entity.Property(e => e.IdUser).HasColumnName("id_user");

            entity.HasOne(d => d.IdRoleNavigation).WithMany()
                .HasForeignKey(d => d.IdRole)
                .HasConstraintName("users_with_roles_fk");

            entity.HasOne(d => d.IdUserNavigation).WithMany()
                .HasForeignKey(d => d.IdUser)
                .HasConstraintName("users_with_roles_fk_1");
        });

        modelBuilder.Entity<Usersrole>(entity =>
        {
            entity.HasKey(e => e.IdRole).HasName("usersroles_pk");

            entity.ToTable("usersroles");

            entity.Property(e => e.IdRole)
                .UseIdentityAlwaysColumn()
                .HasColumnName("id_role");
            entity.Property(e => e.Name)
                .HasColumnType("character varying")
                .HasColumnName("name");
        });

        OnModelCreatingPartial(modelBuilder);
    }

    partial void OnModelCreatingPartial(ModelBuilder modelBuilder);
}
