using System;
using System.Collections.Generic;
using System.Linq;
using Avalonia.Controls;
using AvaloniaApplication3.Models;
using AvaloniaApplication3.Views;
using Microsoft.EntityFrameworkCore;
using ReactiveUI;

namespace AvaloniaApplication3.ViewModels
{
	public class MainPageViewModel : ViewModelBase
	{
		UserControl teacherPage = new EmptyPage();
		UserControl adminPage = new EmptyPage();
		//UserControl main;
		User? currentUser;

        public MainPageViewModel(User? currentUser)
        {
            this.currentUser = currentUser;
            //main = MainAcc;
            SetContent();
        }

        private void SetContent()
        {
            TestDataBaseCheskinaContext db = new TestDataBaseCheskinaContext();
            var allUserRoles = db.UsersWithRoles.Include(u => u.IdRoleNavigation).Where(x => x.IdUser == currentUser.IdUser).ToList();
            foreach (UsersWithRole userRole in allUserRoles)
            {
                switch(userRole.IdRoleNavigation.Name)
                {
                    case "":
                        AdminPage = new AdminPage();
                        //TeacherPage = new TeacherPage();
                        break;
                    case "":
                        TeacherPage = new TeacherPage();
                        break;
                        default: break;
                }
            }
        }

        public void ToPersonalAccount() //    (  )
        {
            MainAcc = new PersonalAccountPage(currentUser);
            //Main = MainAcc;
        }

        public UserControl TeacherPage { get => teacherPage; set => this.RaiseAndSetIfChanged(ref teacherPage, value); }
        public UserControl AdminPage { get => adminPage; set => this.RaiseAndSetIfChanged(ref adminPage, value); }
        //public UserControl Main { get => main; set => this.RaiseAndSetIfChanged(ref main, value); } //  -        
    }
}