﻿using Avalonia.Controls;
using AvaloniaApplication3.Models;
using AvaloniaApplication3.Views;
using ReactiveUI;
using System.Linq;

namespace AvaloniaApplication3.ViewModels
{
    public class MainWindowViewModel : ViewModelBase
    {
        private UserControl currentPage = new AuthorizationPage();
        public UserControl CurrentPage { get => currentPage; set => this.RaiseAndSetIfChanged(ref currentPage, value); }
        public string Login { get => login; set => this.RaiseAndSetIfChanged(ref login, value); }
        public string Pass { get => password; set => this.RaiseAndSetIfChanged(ref password, value); }
        public string ErrorMessage { get => errorMessage; set => this.RaiseAndSetIfChanged(ref errorMessage, value); }
        public User? CurrentUser { get => currentUser; set => currentUser = value; }

        private string login = "";
        private string password = "";
        private string errorMessage = "";
        private User? currentUser = null;

        public void ToAuthorizationPage() //надо решить проблему с тем что они public
        {
            ErrorMessage = "";
            CurrentPage = new AuthorizationPage();
        }
        public void ToRegisterPage()
        {
            ErrorMessage = "";
            CurrentPage = new RegisterPage();
        }
        public void LogIn(Window window)
        {
            TestDataBaseCheskinaContext db = new TestDataBaseCheskinaContext();
            UsersLogin? user = db.UsersLogins.FirstOrDefault(x => x.Login.Equals(Login) && x.Password.Equals(Pass));
            if (user != null)
            {
                ErrorMessage = "";
                CurrentUser = db.Users.FirstOrDefault(x => x.IdUser == user.IdUser);
                if (currentUser != null)
                {
                    //StartWindowViewModel = new StartWindowViewModel(CurrentUser); //тут надо в модель как-то передать, а оно не передается таким образом
                    new StartWindow(currentUser).Show(); //открываем новое окно
                    window.Close(); //закрываем предыдущее
                }
            }
            else
            {
                ErrorMessage = "Введен неверный логин или пароль";
            }
        }
    }
}